using System.Windows.Forms;
using WindowsLive.Writer.Api;

namespace LiveWriterPropertiesPanel
{
    [WriterPlugin
      ("1b4dfa52-ba55-47b1-b795-f4a66af4e834", "Properties Panel",
        PublisherUrl = "http://blog.benhall.me.uk",
        Description = "Properties Panel Test")]
    [InsertableContentSource("Properties")]
    public class PropertiesPanelPlugin : SmartContentSource
    {
        public override DialogResult CreateContent(IWin32Window dialogOwner, ISmartContent newContent)
        {
            return DialogResult.OK;
        }

        public override SmartContentEditor CreateEditor(ISmartContentEditorSite editorSite)
        {
            PropertiesPanelEditor editor = new PropertiesPanelEditor();
            editor.ContentEdited += new System.EventHandler(editor_ContentEdited);
            return editor;
        }

        void editor_ContentEdited(object sender, System.EventArgs e)
        {
            GeneratePublishHtml(pcontent, ppublishingContext);
        }

        private ISmartContent pcontent = null;
        private IPublishingContext ppublishingContext = null;

        public override string GeneratePublishHtml(ISmartContent content, IPublishingContext publishingContext)
        {
            pcontent = content;
            ppublishingContext = publishingContext;

            string str = content.Properties.GetString("FirstProperty", "default");
            if (str.Equals("default"))
                return "GeneratePublishHtml";
            else
                return str;
        }
    }
}
